#ifndef I2CDMA_H_
#define I2CDMA_H_

#include <cyu3error.h>
#include <cyu3i2c.h>
#include <cyu3dma.h>

#define I2C_EEPROM_DVC_ADDRESS  0xAC

#define I2C_DMA_BUF_SIZE  64
#define I2C_DMA_BUF_COUNT 1

CyU3PDmaChannel g_HandleI2cDmaCh; /* DMA Channel handle */

CyBool_t g_bI2cLock;
CyBool_t g_bI2cDmaBusy;

CyU3PDmaBuffer_t g_DmaBufferWrite, g_DmaBufferRead;
uint8_t g_u8WriteDataDma[I2C_DMA_BUF_SIZE];
uint8_t g_u8ReadDataDma[I2C_DMA_BUF_SIZE];


CyU3PReturnStatus_t I2cDmaInit(void);
void I2cDmaIR(CyU3PI2cEvt_t evt, CyU3PI2cError_t error);
void I2cDmaErrorEvent(CyU3PI2cError_t error);
CyU3PReturnStatus_t I2cDmaWrite(uint8_t u8DvcAdr, uint8_t u8SizeAdr, uint8_t *pu8Adr, uint8_t u8SizeData, uint8_t *pu8Data);
CyU3PReturnStatus_t I2cDmaRead(uint8_t u8DvcAdr, uint8_t u8SizeAdr, uint8_t *pu8Adr, uint8_t u8SizeData, uint8_t *pu8Data);
CyU3PReturnStatus_t I2cDmaCommunicate(CyBool_t bIsRead, uint8_t u8DvcAdr, uint8_t u8SizeAdr, uint8_t *pu8Adr, uint8_t u8SizeData, uint8_t *pu8Data);

CyU3PReturnStatus_t I2cDmaCreateDmaChannel(void);
void I2cDmaCallbackDma(CyU3PDmaChannel *chHandle, CyU3PDmaCbType_t type, CyU3PDmaCBInput_t *input);


#endif /* I2CDMA_H_ */
